package com.ruoyi.ibs.dashboard.service.impl;

import java.util.Arrays;
import java.util.List;
import java.util.UUID;

import com.ruoyi.common.annotation.DataSource;
import com.ruoyi.common.enums.DataSourceType;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.ibs.dashboard.domain.LscjAmountRules;
import com.ruoyi.ibs.dashboard.mapper.LscjAmountRulesMapper;
import com.ruoyi.ibs.dashboard.service.ILscjAmountRulesService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;


/**
 * 【请填写功能名称】Service业务层处理
 * 
 * @author ruoyi
 * @date 2025-08-04
 */
@Service
public class LscjAmountRulesServiceImpl implements ILscjAmountRulesService
{
    @Autowired
    private LscjAmountRulesMapper lscjAmountRulesMapper;

    /**
     * 查询【请填写功能名称】
     * 
     * @param id) 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    @Override
    public LscjAmountRules selectLscjAmountRulesById(String id)
    {
        return lscjAmountRulesMapper.selectLscjAmountRulesById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     * 
     * @param lscjAmountRules 【请填写功能名称】
     * @return 【请填写功能名称】
     */
    @Override
    public List<LscjAmountRules> selectLscjAmountRulesList(LscjAmountRules lscjAmountRules)
    {
        lscjAmountRules.setOrgId(SecurityUtils.getDeptId().toString());
        return lscjAmountRulesMapper.selectLscjAmountRulesList(lscjAmountRules);
    }
    @Override
    public int selectLscjAmountRulesListCount(LscjAmountRules lscjAmountRules)
    {
        lscjAmountRules.setOrgId(SecurityUtils.getDeptId().toString());
        return lscjAmountRulesMapper.selectLscjAmountRulesListCount(lscjAmountRules);
    }
    /**
     * 新增【请填写功能名称】
     * 
     * @param lscjAmountRules 【请填写功能名称】
     * @return 结果
     */
    @Override
    @Transactional
    public int insertLscjAmountRules(LscjAmountRules lscjAmountRules)
    {



        LscjAmountRules lscjAmountRules1 = new LscjAmountRules();
        lscjAmountRules1.setOrgId(lscjAmountRules.getOrgId());
        lscjAmountRules1.setLevel(lscjAmountRules.getLevel());
        lscjAmountRules1.setUserId(lscjAmountRules.getUserId());
        lscjAmountRules1.setTransType(lscjAmountRules.getTransType());
        lscjAmountRules1.setSize(1000);
        List<LscjAmountRules> lscjAmountRules2 = this.selectLscjAmountRulesList(lscjAmountRules1);
        if(lscjAmountRules2.size() > 0){
            throw new ServiceException("该层级规则已存在");
        }
        lscjAmountRules.setId(UUID.randomUUID().toString());
        lscjAmountRules.setCreateTime(DateUtils.getNowDate());
        lscjAmountRules.setOrgId(SecurityUtils.getDeptId().toString().substring(0,3)+"000");
        lscjAmountRules.setCreateTime(DateUtils.getNowDate());
        return lscjAmountRulesMapper.insertLscjAmountRules(lscjAmountRules);
    }

    /**
     * 修改【请填写功能名称】
     * 
     * @param lscjAmountRules 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int updateLscjAmountRules(LscjAmountRules lscjAmountRules)
    {
        LscjAmountRules idRule = this.selectLscjAmountRulesById(lscjAmountRules.getId());
        if(idRule != null || idRule.getOrgId().equals(SecurityUtils.getDeptId().toString())){
            throw new ServiceException("权限不足");
        }

        lscjAmountRules.setOrgId(SecurityUtils.getDeptId().toString().substring(0,3)+"000");
        return lscjAmountRulesMapper.updateLscjAmountRules(lscjAmountRules);
    }

    /**
     * 批量删除【请填写功能名称】
     * 
     * @param ids 需要删除的【请填写功能名称】主键
     * @return 结果
     */
    @Override
    @Transactional
    public int deleteLscjAmountRulesByIds(String[] ids)
    {

        for (String id: Arrays.asList(ids) ) {
            LscjAmountRules lscjAmountRules = this.selectLscjAmountRulesById(id);
            if(lscjAmountRules == null){
                throw new ServiceException("权限不足");
            }


            if (lscjAmountRules.getOrgId().equals(SecurityUtils.getDeptId().toString())){
                lscjAmountRulesMapper.deleteLscjAmountRulesByOrgId(id);
            }else{
                throw new ServiceException("权限不足");
            }
        }
        return 1;
    }

    /**
     * 删除【请填写功能名称】信息
     * 
     * @param orgId 【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteLscjAmountRulesByOrgId(String orgId)
    {
        return lscjAmountRulesMapper.deleteLscjAmountRulesByOrgId(orgId);
    }
}
